#include <stddef.h>
#include <stdint.h>
#include "serial.h"
#include "printk.h"
#include "delay.h"
#include "led.h"


/* IMPORTANT!  Uncomment the proper line depending on what Pi you have */

/* For Pi1 */
//#define IO_BASE	0x20000000

/* For Pi2/Pi3 */
//#define IO_BASE	0x3f000000

/* For Pi4 */
//#define IO_BASE	0xfe000000


uint32_t io_base=IO_BASE;

void kernel_main(uint32_t r0, uint32_t r1, uint32_t *atags) {

	int ch;

	(void) r0;	/* Ignore boot method */

	/* Initialize Hardware */
	uart_init();

	/* Turn LED on for debug purposes */
	gpio18_led_on();

	/* Pause so we don't scroll away boot messages before */
	/* The terminal emulator is ready */
	printk("Press any key to continue...\r\n");
	uart_getc();

	/* Print boot message */
// YOUR CODE HERE

	/* Print hardware version */

	printk("Detected processor type %x\r\n",r1);

	printk("Starting message loop\r\n");

	/* Loop forever, echoing what is typed */
	while (1) {
		ch=uart_getc();

		/* Convert to uppercase */
		if ((ch>='a') && (ch<='z')) ch-=32;

		uart_putc(ch);
	}
}
