#include <stdint.h>

#include "bcm2835_periph.h"
#include "mmio.h"

int gpio18_led_on(void) {

	uint32_t old;

	/* Enable GPIO18 in the proper GPFSEL register */

	/* clear out old value */
	/* bit 24 of GPFSEL1 */
	old=bcm2835_read(GPIO_GPFSEL1);
	old &= ~(0x7 << 24);
	old |= (1<<24);
	bcm2835_write(GPIO_GPFSEL1,old);

	/* Write 1 to the proper SET register (turn on the LED) */

	bcm2835_write(GPIO_GPSET0,(1<<18));

	return 0;
}

int gpio18_led_off(void) {

	uint32_t old;

	/* Enable GPIO18 in the proper GPFSEL register */

	/* clear out old value */
	/* bit 24 of GPFSEL1 */
	old=bcm2835_read(GPIO_GPFSEL1);
	old &= ~(0x7 << 24);
	old |= (1<<24);
	bcm2835_write(GPIO_GPFSEL1,old);

	/* Write 1 to the proper CLR register (turn off the LED) */

	bcm2835_write(GPIO_GPCLR0,(1<<18));

	return 0;
}

