extern int io_base;


static inline void mmio2_write(uint32_t address, uint32_t data) {
	uint32_t *ptr = (uint32_t *)address;
	asm volatile("str %[data], [%[address]]" :
		: [address]"r"(ptr), [data]"r"(data));
}

static inline uint32_t mmio2_read(uint32_t address) {
	uint32_t *ptr = (uint32_t *)address;
	uint32_t data;
	asm volatile("ldr %[data], [%[address]]" :
		[data]"=r"(data) : [address]"r"(ptr));
	return data;
}

static inline void bcm2835_write(uint32_t address, uint32_t data) {
        mmio2_write(io_base+address, data);
}

static inline uint32_t bcm2835_read(uint32_t address) {
        return mmio2_read(io_base+address);
}
